/********************************************************************************
********************************************************************************/

#include <QtGui>

#include "stadjdialog.h"


StAdjDialog::StAdjDialog()
{
        setObjectName(QString::fromUtf8("StAdjDialog"));
        resize(369, 262);
        cancelButton = new QPushButton(this);
        cancelButton->setObjectName(QString::fromUtf8("cancelButton"));
        cancelButton->setGeometry(QRect(250, 60, 90, 29));
        okButton = new QPushButton(this);
        okButton->setObjectName(QString::fromUtf8("okButton"));
        okButton->setGeometry(QRect(250, 20, 90, 29));
        okButton->setDefault(true);
        adjBox = new QCheckBox(this);
        adjBox->setObjectName(QString::fromUtf8("adjBox"));
        adjBox->setGeometry(QRect(20, 20, 180, 21));
        textLabel1 = new QLabel(this);
        textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
        textLabel1->setGeometry(QRect(20, 60, 180, 20));
        textLabel1->setWordWrap(false);
        textLabel2 = new QLabel(this);
        textLabel2->setObjectName(QString::fromUtf8("textLabel2"));
        textLabel2->setGeometry(QRect(20, 120, 160, 20));
        textLabel2->setWordWrap(false);
        textLabel3 = new QLabel(this);
        textLabel3->setObjectName(QString::fromUtf8("textLabel3"));
        textLabel3->setGeometry(QRect(190, 120, 140, 20));
        textLabel3->setWordWrap(false);
        n0Edit = new QLineEdit(this);
        n0Edit->setObjectName(QString::fromUtf8("n0Edit"));
        n0Edit->setGeometry(QRect(20, 80, 180, 21));
        timEdit = new QLineEdit(this);
        timEdit->setObjectName(QString::fromUtf8("timEdit"));
        timEdit->setGeometry(QRect(20, 140, 150, 21));
        raEdit = new QLineEdit(this);
        raEdit->setObjectName(QString::fromUtf8("raEdit"));
        raEdit->setGeometry(QRect(190, 140, 150, 21));
        sdp4Box = new QCheckBox(this);
        sdp4Box->setObjectName(QString::fromUtf8("sdp4Box"));
        sdp4Box->setGeometry(QRect(20, 180, 320, 21));
        wgsBox = new QCheckBox(this);
        wgsBox->setObjectName(QString::fromUtf8("wgsBox"));
        wgsBox->setGeometry(QRect(20, 220, 320, 21));
#ifndef QT_NO_SHORTCUT
        textLabel1->setBuddy(n0Edit);
        textLabel2->setBuddy(timEdit);
        textLabel3->setBuddy(raEdit);
#endif // QT_NO_SHORTCUT
        QWidget::setTabOrder(adjBox, n0Edit);
        QWidget::setTabOrder(n0Edit, timEdit);
        QWidget::setTabOrder(timEdit, raEdit);
        QWidget::setTabOrder(raEdit, sdp4Box);
        QWidget::setTabOrder(sdp4Box, wgsBox);
        QWidget::setTabOrder(wgsBox, okButton);
        QWidget::setTabOrder(okButton, cancelButton);

        connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
        connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));

        setWindowTitle(QApplication::translate("StAdjDialog", "Adjust Orbit Elements", 0, QApplication::UnicodeUTF8));
        cancelButton->setText(QApplication::translate("StAdjDialog", "&Cancel", 0, QApplication::UnicodeUTF8));
        cancelButton->setShortcut(QApplication::translate("StAdjDialog", "Alt+C", 0, QApplication::UnicodeUTF8));
        okButton->setText(QApplication::translate("StAdjDialog", "&OK", 0, QApplication::UnicodeUTF8));
        okButton->setShortcut(QApplication::translate("StAdjDialog", "Alt+O", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        adjBox->setToolTip(QApplication::translate("StAdjDialog", "Activate Orbit Element Adjustment", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        adjBox->setWhatsThis(QApplication::translate("StAdjDialog", "If marked new orbit elements which are read from a TLE file will be adjusted according to the values set here. Already selected satellites will not be affected.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        adjBox->setText(QApplication::translate("StAdjDialog", "&Activate Adjustment", 0, QApplication::UnicodeUTF8));
        adjBox->setShortcut(QApplication::translate("StAdjDialog", "Alt+A", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel1->setToolTip(QApplication::translate("StAdjDialog", "Set Mean Motion to a fixed value.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel1->setWhatsThis(QApplication::translate("StAdjDialog", "The value of the Mean Motion (n0) of newly read TLE's will be set to this fixed value. If set 0 the n0 value will be left unchanged. Setting all n0 values of a satellite constellation to a fixed value will ensure that the relative positions stay the same.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel1->setText(QApplication::translate("StAdjDialog", "Set &Mean Motion (n0):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel2->setToolTip(QApplication::translate("StAdjDialog", "Adjust epoch of orbit elements.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel2->setWhatsThis(QApplication::translate("StAdjDialog", "The value of the epoch of newly read TLE's will be adjusted by this amount in seconds. This can help to get the timing right for a satellite.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel2->setText(QApplication::translate("StAdjDialog", "Adjust &Epoch (sec):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel3->setToolTip(QApplication::translate("StAdjDialog", "Adjust Right Ascension of the Ascending Node.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel3->setWhatsThis(QApplication::translate("StAdjDialog", "The value of the Ascending Node of newly read TLE's will be adjusted by this amount in degrees. This can be used to get the orbit plane right.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel3->setText(QApplication::translate("StAdjDialog", "Adjust &R.A.(deg):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        sdp4Box->setToolTip(QApplication::translate("StAdjDialog", "Allow use of SDP4 model.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        sdp4Box->setWhatsThis(QApplication::translate("StAdjDialog", "If marked orbits with periods > 225 minutes will be propagated with the SDP4 model if the SGP4 model was selected. Otherwise the SGP4 model will be used even for those orbits. This may be needed for TLEs which were generated using the SGP4 instead of the SDP4 model.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        sdp4Box->setText(QApplication::translate("StAdjDialog", "Use SDP&4  model for long period orbits.", 0, QApplication::UnicodeUTF8));
        sdp4Box->setShortcut(QApplication::translate("StAdjDialog", "Alt+4", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        wgsBox->setToolTip(QApplication::translate("StAdjDialog", "Switch between WGS84 and WGS72 constants.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        wgsBox->setWhatsThis(QApplication::translate("StAdjDialog", "This is only used for the SGP4/SDP4 model. The differences between the constants are very small.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        wgsBox->setText(QApplication::translate("StAdjDialog", "Use &WGS84 constants for SGP4 model.", 0, QApplication::UnicodeUTF8));
        wgsBox->setShortcut(QApplication::translate("StAdjDialog", "Alt+W", 0, QApplication::UnicodeUTF8));

};

void StAdjDialog::setParams( bool sdp4, bool adjflg, double adjtim, double adjn0, double adjra, int wgs )
{
 QString s;
 char addat[15];
 
 sdp4Box->setChecked(sdp4);
 adjBox->setChecked(adjflg);
 wgsBox->setChecked(wgs == 1);
 s.setNum(adjtim);
 timEdit->setText(s);
 sprintf (addat,"%12.8lf",adjn0);
 s = addat;
 n0Edit->setText(s);
 sprintf (addat,"%9.4lf",adjra);
 s = addat;
 raEdit->setText(s);
}

void StAdjDialog::getParams(bool &sdp4,  bool &adjflg, double &adjtim, double &adjn0, double &adjra, int &wgs )
{
 QString s;
 
 sdp4 = sdp4Box->isChecked();
 adjflg = adjBox->isChecked();
 if (wgsBox->isChecked()) wgs = 1;
 else wgs = 0;
 s = timEdit->text();
 adjtim = s.toDouble();
 s = n0Edit->text();
 adjn0 = s.toDouble();
 s = raEdit->text();
 adjra = s.toDouble();
}
