/********************************************************************************
********************************************************************************/

#include <QtGui>

#include "steditorbdialog.h"
#include <qinputdialog.h>
#include "satcalview.h"
#include "attlib.h"
#include "astrolib.h"
#include "ststatedialog.h"
#include "stdatedialog.h"
#include "stadjdialog.h"

bool numcng, ednwsflg;
int  apc, n0c, ndc;
double hper, hapo;
double dn0, dsmax, decc, dndot, dadot;
char ndat[32];
	
StEditOrbDialog::StEditOrbDialog()
{
        setObjectName(QString::fromUtf8("StEditOrbDialog"));
        resize(590, 494);
        nameEdit = new QLineEdit(this);
        nameEdit->setObjectName(QString::fromUtf8("nameEdit"));
        nameEdit->setGeometry(QRect(20, 30, 230, 21));
        yearEdit = new QLineEdit(this);
        yearEdit->setObjectName(QString::fromUtf8("yearEdit"));
        yearEdit->setGeometry(QRect(20, 90, 100, 21));
        raEdit = new QLineEdit(this);
        raEdit->setObjectName(QString::fromUtf8("raEdit"));
        raEdit->setGeometry(QRect(20, 150, 160, 21));
        textLabel6 = new QLabel(this);
        textLabel6->setObjectName(QString::fromUtf8("textLabel6"));
        textLabel6->setGeometry(QRect(200, 130, 130, 20));
        textLabel6->setWordWrap(false);
        aperEdit = new QLineEdit(this);
        aperEdit->setObjectName(QString::fromUtf8("aperEdit"));
        aperEdit->setGeometry(QRect(200, 150, 130, 21));
        textLabel8 = new QLabel(this);
        textLabel8->setObjectName(QString::fromUtf8("textLabel8"));
        textLabel8->setGeometry(QRect(20, 190, 140, 20));
        textLabel8->setWordWrap(false);
        n0Edit = new QLineEdit(this);
        n0Edit->setObjectName(QString::fromUtf8("n0Edit"));
        n0Edit->setGeometry(QRect(20, 330, 210, 21));
        textLabel16 = new QLabel(this);
        textLabel16->setObjectName(QString::fromUtf8("textLabel16"));
        textLabel16->setGeometry(QRect(20, 430, 170, 20));
        textLabel16->setWordWrap(false);
        adotEdit = new QLineEdit(this);
        adotEdit->setObjectName(QString::fromUtf8("adotEdit"));
        adotEdit->setGeometry(QRect(200, 390, 140, 21));
        ndotEdit = new QLineEdit(this);
        ndotEdit->setObjectName(QString::fromUtf8("ndotEdit"));
        ndotEdit->setGeometry(QRect(20, 390, 150, 21));
        n2dotEdit = new QLineEdit(this);
        n2dotEdit->setObjectName(QString::fromUtf8("n2dotEdit"));
        n2dotEdit->setGeometry(QRect(20, 450, 150, 21));
        textLabel7 = new QLabel(this);
        textLabel7->setObjectName(QString::fromUtf8("textLabel7"));
        textLabel7->setGeometry(QRect(360, 130, 140, 20));
        textLabel7->setWordWrap(false);
        m0Edit = new QLineEdit(this);
        m0Edit->setObjectName(QString::fromUtf8("m0Edit"));
        m0Edit->setGeometry(QRect(350, 150, 140, 21));
        textLabel12 = new QLabel(this);
        textLabel12->setObjectName(QString::fromUtf8("textLabel12"));
        textLabel12->setGeometry(QRect(20, 310, 210, 20));
        textLabel12->setWordWrap(false);
        textLabel3 = new QLabel(this);
        textLabel3->setObjectName(QString::fromUtf8("textLabel3"));
        textLabel3->setGeometry(QRect(20, 70, 130, 20));
        textLabel3->setWordWrap(false);
        textLabel2 = new QLabel(this);
        textLabel2->setObjectName(QString::fromUtf8("textLabel2"));
        textLabel2->setGeometry(QRect(270, 10, 70, 20));
        textLabel2->setWordWrap(false);
        noradEdit = new QLineEdit(this);
        noradEdit->setObjectName(QString::fromUtf8("noradEdit"));
        noradEdit->setGeometry(QRect(270, 30, 90, 21));
        textLabel4 = new QLabel(this);
        textLabel4->setObjectName(QString::fromUtf8("textLabel4"));
        textLabel4->setGeometry(QRect(150, 70, 210, 20));
        textLabel4->setWordWrap(false);
        dayEdit = new QLineEdit(this);
        dayEdit->setObjectName(QString::fromUtf8("dayEdit"));
        dayEdit->setGeometry(QRect(150, 90, 220, 21));
        textLabel17 = new QLabel(this);
        textLabel17->setObjectName(QString::fromUtf8("textLabel17"));
        textLabel17->setGeometry(QRect(200, 430, 100, 20));
        textLabel17->setWordWrap(false);
        bstarEdit = new QLineEdit(this);
        bstarEdit->setObjectName(QString::fromUtf8("bstarEdit"));
        bstarEdit->setGeometry(QRect(200, 450, 130, 21));
        cancelButton = new QPushButton(this);
        cancelButton->setObjectName(QString::fromUtf8("cancelButton"));
        cancelButton->setGeometry(QRect(479, 448, 80, 29));
        okButton = new QPushButton(this);
        okButton->setObjectName(QString::fromUtf8("okButton"));
        okButton->setGeometry(QRect(479, 412, 80, 29));
        okButton->setDefault(true);
        textLabel1_2 = new QLabel(this);
        textLabel1_2->setObjectName(QString::fromUtf8("textLabel1_2"));
        textLabel1_2->setGeometry(QRect(380, 10, 180, 20));
        textLabel1_2->setWordWrap(false);
        idsnEdit = new QLineEdit(this);
        idsnEdit->setObjectName(QString::fromUtf8("idsnEdit"));
        idsnEdit->setGeometry(QRect(380, 30, 170, 21));
        periEdit = new QLineEdit(this);
        periEdit->setObjectName(QString::fromUtf8("periEdit"));
        periEdit->setGeometry(QRect(20, 270, 130, 21));
        textLabel11 = new QLabel(this);
        textLabel11->setObjectName(QString::fromUtf8("textLabel11"));
        textLabel11->setGeometry(QRect(170, 250, 140, 20));
        textLabel11->setWordWrap(false);
        apoEdit = new QLineEdit(this);
        apoEdit->setObjectName(QString::fromUtf8("apoEdit"));
        apoEdit->setGeometry(QRect(170, 270, 130, 21));
        textLabel9 = new QLabel(this);
        textLabel9->setObjectName(QString::fromUtf8("textLabel9"));
        textLabel9->setGeometry(QRect(170, 190, 120, 20));
        textLabel9->setWordWrap(false);
        incEdit = new QLineEdit(this);
        incEdit->setObjectName(QString::fromUtf8("incEdit"));
        incEdit->setGeometry(QRect(170, 210, 104, 21));
        eccEdit = new QLineEdit(this);
        eccEdit->setObjectName(QString::fromUtf8("eccEdit"));
        eccEdit->setGeometry(QRect(20, 210, 130, 21));
        textLabel1 = new QLabel(this);
        textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
        textLabel1->setGeometry(QRect(20, 10, 110, 20));
        textLabel1->setWordWrap(false);
        textLabel15 = new QLabel(this);
        textLabel15->setObjectName(QString::fromUtf8("textLabel15"));
        textLabel15->setGeometry(QRect(200, 370, 150, 20));
        textLabel15->setWordWrap(false);
        refreshButton = new QPushButton(this);
        refreshButton->setObjectName(QString::fromUtf8("refreshButton"));
        refreshButton->setGeometry(QRect(470, 360, 90, 29));
        textLabel14 = new QLabel(this);
        textLabel14->setObjectName(QString::fromUtf8("textLabel14"));
        textLabel14->setGeometry(QRect(20, 370, 140, 20));
        textLabel14->setWordWrap(false);
        aEdit = new QLineEdit(this);
        aEdit->setObjectName(QString::fromUtf8("aEdit"));
        aEdit->setGeometry(QRect(250, 330, 200, 21));
        stateButton = new QPushButton(this);
        stateButton->setObjectName(QString::fromUtf8("stateButton"));
        stateButton->setGeometry(QRect(470, 190, 90, 29));
        adjButton = new QPushButton(this);
        adjButton->setObjectName(QString::fromUtf8("adjButton"));
        adjButton->setGeometry(QRect(470, 230, 90, 29));
        geoButton = new QPushButton(this);
        geoButton->setObjectName(QString::fromUtf8("geoButton"));
        geoButton->setGeometry(QRect(470, 270, 90, 29));
        textLabel10 = new QLabel(this);
        textLabel10->setObjectName(QString::fromUtf8("textLabel10"));
        textLabel10->setGeometry(QRect(20, 250, 140, 20));
        textLabel10->setWordWrap(false);
        perapBox = new QCheckBox(this);
        perapBox->setObjectName(QString::fromUtf8("perapBox"));
        perapBox->setGeometry(QRect(320, 270, 140, 21));
        timeButton = new QPushButton(this);
        timeButton->setObjectName(QString::fromUtf8("timeButton"));
        timeButton->setGeometry(QRect(397, 80, 100, 29));
        nwsButton = new QPushButton(this);
        nwsButton->setObjectName(QString::fromUtf8("nwsButton"));
        nwsButton->setGeometry(QRect(470, 310, 90, 29));
        textLabel5 = new QLabel(this);
        textLabel5->setObjectName(QString::fromUtf8("textLabel5"));
        textLabel5->setGeometry(QRect(20, 130, 140, 20));
        textLabel5->setWordWrap(false);
        textLabel13 = new QLabel(this);
        textLabel13->setObjectName(QString::fromUtf8("textLabel13"));
        textLabel13->setGeometry(QRect(250, 310, 160, 20));
        textLabel13->setWordWrap(false);
        spg4Box = new QCheckBox(this);
        spg4Box->setObjectName(QString::fromUtf8("spg4Box"));
        spg4Box->setGeometry(QRect(340, 450, 120, 21));
        numBox = new QCheckBox(this);
        numBox->setObjectName(QString::fromUtf8("numBox"));
        numBox->setGeometry(QRect(320, 190, 140, 21));
#ifndef QT_NO_SHORTCUT
        textLabel6->setBuddy(aperEdit);
        textLabel8->setBuddy(eccEdit);
        textLabel16->setBuddy(n2dotEdit);
        textLabel7->setBuddy(m0Edit);
        textLabel12->setBuddy(n0Edit);
        textLabel3->setBuddy(yearEdit);
        textLabel2->setBuddy(noradEdit);
        textLabel4->setBuddy(dayEdit);
        textLabel17->setBuddy(bstarEdit);
        textLabel1_2->setBuddy(idsnEdit);
        textLabel11->setBuddy(apoEdit);
        textLabel9->setBuddy(incEdit);
        textLabel1->setBuddy(nameEdit);
        textLabel15->setBuddy(adotEdit);
        textLabel14->setBuddy(ndotEdit);
        textLabel10->setBuddy(periEdit);
        textLabel5->setBuddy(raEdit);
        textLabel13->setBuddy(aEdit);
#endif // QT_NO_SHORTCUT
        QWidget::setTabOrder(nameEdit, noradEdit);
        QWidget::setTabOrder(noradEdit, idsnEdit);
        QWidget::setTabOrder(idsnEdit, yearEdit);
        QWidget::setTabOrder(yearEdit, dayEdit);
        QWidget::setTabOrder(dayEdit, timeButton);
        QWidget::setTabOrder(timeButton, raEdit);
        QWidget::setTabOrder(raEdit, aperEdit);
        QWidget::setTabOrder(aperEdit, m0Edit);
        QWidget::setTabOrder(m0Edit, eccEdit);
        QWidget::setTabOrder(eccEdit, incEdit);
        QWidget::setTabOrder(incEdit, numBox);
        QWidget::setTabOrder(numBox, stateButton);
        QWidget::setTabOrder(stateButton, periEdit);
        QWidget::setTabOrder(periEdit, apoEdit);
        QWidget::setTabOrder(apoEdit, perapBox);
        QWidget::setTabOrder(perapBox, n0Edit);
        QWidget::setTabOrder(n0Edit, aEdit);
        QWidget::setTabOrder(aEdit, adjButton);
        QWidget::setTabOrder(adjButton, geoButton);
        QWidget::setTabOrder(geoButton, nwsButton);
        QWidget::setTabOrder(nwsButton, ndotEdit);
        QWidget::setTabOrder(ndotEdit, adotEdit);
        QWidget::setTabOrder(adotEdit, n2dotEdit);
        QWidget::setTabOrder(n2dotEdit, bstarEdit);
        QWidget::setTabOrder(bstarEdit, spg4Box);
        QWidget::setTabOrder(spg4Box, refreshButton);
        QWidget::setTabOrder(refreshButton, okButton);
        QWidget::setTabOrder(okButton, cancelButton);

 connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
 connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));
 connect(refreshButton,SIGNAL(clicked()),this,SLOT(refreshSlot()));
 connect(perapBox, SIGNAL(toggled(bool)), this, SLOT(perapoSlot()));
 connect(spg4Box, SIGNAL(toggled(bool)), this, SLOT(spgSlot()));
 connect(n0Edit, SIGNAL(textChanged(QString)), this, SLOT(n0Slot()));
 connect(aEdit,SIGNAL(textChanged(QString)),this,SLOT(smaxSlot()));
 connect(ndotEdit,SIGNAL(textChanged(QString)),this,SLOT(ndotSlot()));
 connect(adotEdit,SIGNAL(textChanged(QString)),this,SLOT(adotSlot()));
 connect(periEdit,SIGNAL(textChanged(QString)),this,SLOT(perSlot()));
 connect(apoEdit, SIGNAL(textChanged(QString)), this, SLOT(apoSlot()));
 connect(eccEdit, SIGNAL(textChanged(QString)), this, SLOT(eccSlot()));
 connect(incEdit,SIGNAL(textChanged(QString)),this,SLOT(eccincSlot()));
 connect(stateButton, SIGNAL(clicked()), this, SLOT(stateSlot()));
 connect(adjButton, SIGNAL(clicked()), this, SLOT(adjSlot()));
 connect(geoButton, SIGNAL(clicked()), this, SLOT(geoSlot()));
 connect(timeButton, SIGNAL(clicked()), this, SLOT(timeSlot()));
 connect(numBox, SIGNAL(toggled(bool)), this, SLOT(numSlot()));
 connect(nwsButton, SIGNAL(clicked()), this, SLOT(nwsSlot()));
 connect(nwsButton, SIGNAL(clicked()), this, SLOT(accept()));

        setWindowTitle(QApplication::translate("StEditOrbDialog", "Edit Orbit Elements", 0, QApplication::UnicodeUTF8));
        textLabel6->setText(QApplication::translate("StEditOrbDialog", "Arg.of &Perigee (deg):", 0, QApplication::UnicodeUTF8));
        textLabel8->setText(QApplication::translate("StEditOrbDialog", "&Eccentricity:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel16->setToolTip(QApplication::translate("StEditOrbDialog", "Second derivative of Mean Motion", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel16->setWhatsThis(QApplication::translate("StEditOrbDialog", "Second derivative of Mean Motion. Rarely used.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel16->setText(QApplication::translate("StEditOrbDialog", "n&2dot (rev/day^3): ", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        adotEdit->setToolTip(QApplication::translate("StEditOrbDialog", "Daily change of Semimajor Axis", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        adotEdit->setWhatsThis(QApplication::translate("StEditOrbDialog", "First derivative of Semimajor Axis", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
#ifndef QT_NO_TOOLTIP
        ndotEdit->setToolTip(QApplication::translate("StEditOrbDialog", "First derivative of the Mean Motion", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        ndotEdit->setWhatsThis(QApplication::translate("StEditOrbDialog", "First derivative of the Mean Motion", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
#ifndef QT_NO_TOOLTIP
        n2dotEdit->setToolTip(QApplication::translate("StEditOrbDialog", "Second derivative of Mean Motion.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        n2dotEdit->setWhatsThis(QApplication::translate("StEditOrbDialog", "Second derivative of Mean Motion. Rarely used.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
#ifndef QT_NO_TOOLTIP
        textLabel7->setToolTip(QApplication::translate("StEditOrbDialog", "Mean Anomaly", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel7->setWhatsThis(QApplication::translate("StEditOrbDialog", "The Mean Anomaly will be set 0 for non-elliptic orbits.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel7->setText(QApplication::translate("StEditOrbDialog", "&Mean Anomaly (deg):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        m0Edit->setToolTip(QApplication::translate("StEditOrbDialog", "Mean Anomaly", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        m0Edit->setWhatsThis(QApplication::translate("StEditOrbDialog", "The Mean Anomaly will be set to 0 for non-elliptic orbits.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
#ifndef QT_NO_TOOLTIP
        textLabel12->setToolTip(QApplication::translate("StEditOrbDialog", "Mean Motion", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel12->setWhatsThis(QApplication::translate("StEditOrbDialog", "Mean Motion for elliptic orbits. Perigee for hyperbolic orbits.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel12->setText(QApplication::translate("StEditOrbDialog", "Mean Motio&n (rev/day):  ||  q (km):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel3->setToolTip(QApplication::translate("StEditOrbDialog", "Year of Epoch", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel3->setWhatsThis(QApplication::translate("StEditOrbDialog", "For hyperbolic orbits the epoch will be taken as the time of perigee.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel3->setText(QApplication::translate("StEditOrbDialog", "&Year of epoch:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel2->setToolTip(QApplication::translate("StEditOrbDialog", "NORAD catalog number", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel2->setWhatsThis(QApplication::translate("StEditOrbDialog", "NORAD number. You can normally ignore this.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel2->setText(QApplication::translate("StEditOrbDialog", "NORA&D#:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        noradEdit->setToolTip(QApplication::translate("StEditOrbDialog", "NORAD catalog number", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        noradEdit->setWhatsThis(QApplication::translate("StEditOrbDialog", "NORAD number. You can normally ignore this", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
#ifndef QT_NO_TOOLTIP
        textLabel4->setToolTip(QApplication::translate("StEditOrbDialog", "Day of Epoch", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel4->setWhatsThis(QApplication::translate("StEditOrbDialog", "For hyperbolic orbits the epoch will be taken as the time of perigee. ", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel4->setText(QApplication::translate("StEditOrbDialog", "Day of Year. &Fraction of day:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel17->setToolTip(QApplication::translate("StEditOrbDialog", "Ballistic coefficient for the SPG4 Model", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel17->setWhatsThis(QApplication::translate("StEditOrbDialog", "Parameter used by the SGP4 Model to take care of atmospheric friction etc.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel17->setText(QApplication::translate("StEditOrbDialog", "&BSTAR:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        bstarEdit->setToolTip(QApplication::translate("StEditOrbDialog", "Ballistic coefficient used by the SPG4 model.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        bstarEdit->setWhatsThis(QApplication::translate("StEditOrbDialog", "Parameter used by the SPG4 model to account for atmospheric friction etc.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        cancelButton->setText(QApplication::translate("StEditOrbDialog", "&Cancel", 0, QApplication::UnicodeUTF8));
        cancelButton->setShortcut(QApplication::translate("StEditOrbDialog", "Alt+C", 0, QApplication::UnicodeUTF8));
        okButton->setText(QApplication::translate("StEditOrbDialog", "&OK", 0, QApplication::UnicodeUTF8));
        okButton->setShortcut(QApplication::translate("StEditOrbDialog", "Alt+O", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel1_2->setToolTip(QApplication::translate("StEditOrbDialog", "International Launch Designator", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel1_2->setWhatsThis(QApplication::translate("StEditOrbDialog", "This should be entered in its full format e.g. 1998-067A .", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel1_2->setText(QApplication::translate("StEditOrbDialog", "International &Launch #:", 0, QApplication::UnicodeUTF8));
        textLabel11->setText(QApplication::translate("StEditOrbDialog", "Apogee &Height (km):", 0, QApplication::UnicodeUTF8));
        textLabel9->setText(QApplication::translate("StEditOrbDialog", "&Inclination (deg):", 0, QApplication::UnicodeUTF8));
        textLabel1->setText(QApplication::translate("StEditOrbDialog", "&Satellite Name:", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel15->setToolTip(QApplication::translate("StEditOrbDialog", "Daily change of Semimajor Axis", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel15->setWhatsThis(QApplication::translate("StEditOrbDialog", "First derivative of Semimajor Axis.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel15->setText(QApplication::translate("StEditOrbDialog", "adot (&km/day):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        refreshButton->setToolTip(QApplication::translate("StEditOrbDialog", "Refresh all orbit elements.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        refreshButton->setWhatsThis(QApplication::translate("StEditOrbDialog", "Update all elements in the table to be consistent after some elements have been modified. This will also be done automatically if you leave the dialog.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        refreshButton->setText(QApplication::translate("StEditOrbDialog", "&Refresh", 0, QApplication::UnicodeUTF8));
        refreshButton->setShortcut(QApplication::translate("StEditOrbDialog", "Alt+R", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel14->setToolTip(QApplication::translate("StEditOrbDialog", "First derivative of the Mean Motion", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel14->setWhatsThis(QApplication::translate("StEditOrbDialog", "First derivative of the Mean Motion", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel14->setText(QApplication::translate("StEditOrbDialog", "ndot &(rev/day^2):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        stateButton->setToolTip(QApplication::translate("StEditOrbDialog", "State Vector", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        stateButton->setWhatsThis(QApplication::translate("StEditOrbDialog", "Enter Elements as State Vector.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        stateButton->setText(QApplication::translate("StEditOrbDialog", "State &Vec.", 0, QApplication::UnicodeUTF8));
        stateButton->setShortcut(QApplication::translate("StEditOrbDialog", "Alt+V", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        adjButton->setToolTip(QApplication::translate("StEditOrbDialog", "Adjust Orbit Elements.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        adjButton->setWhatsThis(QApplication::translate("StEditOrbDialog", "Adjust the orbit elements which are read from an older TLE file to fit new observations. This could be useful for satellite constellations which are maintained but not for quickly decaying orbits.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        adjButton->setText(QApplication::translate("StEditOrbDialog", "Ad&just", 0, QApplication::UnicodeUTF8));
        adjButton->setShortcut(QApplication::translate("StEditOrbDialog", "Alt+J", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        geoButton->setToolTip(QApplication::translate("StEditOrbDialog", "Geostationary Satellite.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        geoButton->setWhatsThis(QApplication::translate("StEditOrbDialog", "Generates the orbit elements for a geostationary satellite of know geographic longitude.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        geoButton->setText(QApplication::translate("StEditOrbDialog", "&GEO", 0, QApplication::UnicodeUTF8));
        geoButton->setShortcut(QApplication::translate("StEditOrbDialog", "Alt+G", 0, QApplication::UnicodeUTF8));
        textLabel10->setText(QApplication::translate("StEditOrbDialog", "Perigee Height (km&):", 0, QApplication::UnicodeUTF8));
        perapBox->setText(QApplication::translate("StEditOrbDialog", "Perigee&/Apogee", 0, QApplication::UnicodeUTF8));
        perapBox->setShortcut(QApplication::translate("StEditOrbDialog", "Alt+/", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        timeButton->setToolTip(QApplication::translate("StEditOrbDialog", "Edit the date of epoch.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        timeButton->setWhatsThis(QApplication::translate("StEditOrbDialog", "Edit the time of epoch via the normal Date/Time dialog.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        timeButton->setText(QApplication::translate("StEditOrbDialog", "Edit &Time", 0, QApplication::UnicodeUTF8));
        timeButton->setShortcut(QApplication::translate("StEditOrbDialog", "Alt+T", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        nwsButton->setToolTip(QApplication::translate("StEditOrbDialog", "New satellite", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        nwsButton->setWhatsThis(QApplication::translate("StEditOrbDialog", "Define a new set of orbit elements.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        nwsButton->setText(QApplication::translate("StEditOrbDialog", "Ne&w", 0, QApplication::UnicodeUTF8));
        nwsButton->setShortcut(QApplication::translate("StEditOrbDialog", "Alt+W", 0, QApplication::UnicodeUTF8));
        textLabel5->setText(QApplication::translate("StEditOrbDialog", "Right &Ascension (deg):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel13->setToolTip(QApplication::translate("StEditOrbDialog", "Semimajor Axis", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel13->setWhatsThis(QApplication::translate("StEditOrbDialog", "The Semimajor Axis will be ignored for parabolic orbits.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel13->setText(QApplication::translate("StEditOrbDialog", "Semimajor A&xis (km):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        spg4Box->setToolTip(QApplication::translate("StEditOrbDialog", "Orbit model used for TLE's.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        spg4Box->setWhatsThis(QApplication::translate("StEditOrbDialog", "Orbit model recommended for use with the Two Line Elements supplied by USSPACECOM. Deselect this model if you perform SatCal maneuver calculations.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        spg4Box->setText(QApplication::translate("StEditOrbDialog", "SGP&4 Model", 0, QApplication::UnicodeUTF8));
        spg4Box->setShortcut(QApplication::translate("StEditOrbDialog", "Alt+4", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        numBox->setToolTip(QApplication::translate("StEditOrbDialog", "Numeric orbit propagation", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        numBox->setWhatsThis(QApplication::translate("StEditOrbDialog", "If marked the orbit will be integrated numerically. If unmarked the analytical SGP4 model or the simple Keplerian orbit model will be used.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        numBox->setText(QApplication::translate("StEditOrbDialog", "N&umeric Prop.", 0, QApplication::UnicodeUTF8));
        numBox->setShortcut(QApplication::translate("StEditOrbDialog", "Alt+U", 0, QApplication::UnicodeUTF8));

};

void StEditOrbDialog::refreshSlot()
{
  double day, dinc;
  int aflg;
  bool paf;
  QString s;

  s = incEdit->text();
  dinc = s.toDouble();
  s = eccEdit->text();
	decc = s.toDouble();
  if (decc >= 1.0)
   {
    if (spg4Box->isChecked()) spg4Box->setChecked(false);
   };
  paf = perapBox->isChecked();
  if (spg4Box->isChecked()) aflg = 1;
  else aflg = 0;

  if (paf)  // calculate via perigee and apogee
	 {
	  if (apc)
	   {
      s = periEdit->text(); 

		  hper = s.toDouble();
      s = apoEdit->text();
		  hapo = s.toDouble();

		  dsmax = 6378.14 + (hper + hapo) / 2.0;  // semi-major axis
		  if (dsmax < 1.0) dsmax = 1.0;
		  decc = (hapo - hper) / (2.0*dsmax);     // eccentricity
		  if(decc < 0) decc = -decc;
		  if (decc >= 1.0) decc = 0.9999999;
		  dn0 = getn0(dsmax, decc, dinc);
	   }; //apc
	 }
  else
	 {
	  if (decc < 1.0)  // elliptic
     {
      if (n0c == 0) // just in case it was hyperbolic before
       {
        s = aEdit->text();
		    if(s.toDouble() < 0.0) n0c = 1;
       };   
	    if (n0c)
	     {
        s = n0Edit->text(); 
		    day = s.toDouble();
		    if ((n0c == 2) || (day < 0.0001))
		     {
          s = aEdit->text(); 
		      dsmax = s.toDouble();;
		      dn0 = getn0(dsmax, decc, dinc);
		     }
		    else
		     {
		      dn0 = day;
		      dsmax = getsax(aflg, dn0, decc, dinc);
		     };
		    if (dn0 == 0) dn0 = 0.01; // just in case
	     };  // n0c
	    hper = dsmax*(1.0-decc) - 6378.14;
	    hapo = dsmax*(1.0+decc) - 6378.14;
     }
    else  // hyperbolic
     {
	    if (n0c)
	     {
        s = n0Edit->text();
		    day = s.toDouble();
		    if ((n0c == 2) || (day < 0.0001))
		     {
          s = aEdit->text();
		      dsmax = s.toDouble();;
		      dn0 = dsmax * (1.0 - decc);
          if (dn0 < 0) dn0 = -dn0;
		     }
		    else
		     {
		      dn0 = day;
		      dsmax = 1.0 - decc;
          if (dsmax < 0) dsmax = dn0 / dsmax;
		     };
		    if (dn0 == 0) dn0 = 0.01; // just in case
	     };  // n0c
      hper = 0.0;
      hapo = 0.0; 
      apc = 0;
      n0c = 0;
      ndc = 0;
     };  
	 };  // paf

  if (ndc || n0c || apc)   // ndot or adot have changed
	 {
	  if (ndc == 2)
     {
      s = adotEdit->text(); 
		  dadot = s.toDouble();
		  if (dsmax != 0) dndot = -0.75 * dn0	* dadot / dsmax;
		  else dndot = 0;
	   }
	  else
	   {
      s = ndotEdit->text(); 
		  dndot = s.toDouble();;
		  if (dn0 != 0) dadot = -(4.0/3.0) * dsmax * dndot / dn0;
		  else dadot = 0;
	   };
	 };  // ndc

  // update display
  if (decc < 1.0) sprintf (ndat,"%12.8lf",dn0);
  else sprintf (ndat,"%12.4lf",dn0);
  s = ndat;
  n0Edit->setText(s);
  sprintf (ndat,"%12.4lf",dsmax);
  s = ndat;
  aEdit->setText(s);
  if (decc < 1.0) sprintf (ndat,"%9.7lf",decc);
  else sprintf (ndat,"%11.7lf",decc);
  s = ndat;
  eccEdit->setText(s);
  sprintf (ndat,"%9.4lf",dadot);
  s = ndat;
  adotEdit->setText(s);
  sprintf (ndat,"%12.8lf",dndot);
  s = ndat;
  ndotEdit->setText(s);
  sprintf (ndat,"%12.4lf",hper);
  s = ndat;
  periEdit->setText(s);
  sprintf (ndat,"%12.4lf",hapo);
  s = ndat;
  apoEdit->setText(s);

  apc = 0;
  n0c = 0;
  ndc = 0;
}

void StEditOrbDialog::spgSlot()
{
  bool afl;
  
  afl = spg4Box->isChecked();
  ndotEdit->setEnabled(!afl);
  adotEdit->setEnabled(!afl);
  n2dotEdit->setEnabled(!afl);
  bstarEdit->setEnabled(afl);
  n0c = 3;
}

void StEditOrbDialog::perapoSlot()
{
  bool paf;
  
  paf = perapBox->isChecked();
  periEdit->setEnabled(paf);
  apoEdit->setEnabled(paf);
  eccEdit->setEnabled(!paf);
  n0Edit->setEnabled(!paf);
  aEdit->setEnabled(!paf);
}

void StEditOrbDialog::n0Slot()
{
  n0c = 1;
}

void StEditOrbDialog::smaxSlot()
{
  n0c = 2;
}

void StEditOrbDialog::ndotSlot()
{
  ndc = 1;
}

void StEditOrbDialog::adotSlot()
{
  ndc = 2;
}

void StEditOrbDialog::perSlot()
{
  apc = 1;
}

void StEditOrbDialog::apoSlot()
{
  apc = 2;
}

void StEditOrbDialog::eccincSlot()
{
  apc = 3;
  if (n0c == 1) n0c = 0;
}

void StEditOrbDialog::setParam1( QString fsname, int norad, int aflg, int paflg, double mjdep, int lcflg )
{
	int day, month, year;
	double hour;
  QString s;

  caldat (mjdep, day, month, year, hour);
	hour = mjdep - mjd(0,1,year,0);

  nameEdit->setText(fsname);
  s.setNum(norad);
  noradEdit->setText(s);
  s.setNum(year);
  yearEdit->setText(s);
  sprintf (ndat,"%12.8lf", hour);
  s = ndat;
  dayEdit->setText(s);
  if (aflg) spg4Box->setChecked(true);
  else spg4Box->setChecked(false);
  if (paflg) perapBox->setChecked(true);
  else perapBox->setChecked(false);
	periEdit->setEnabled(paflg==1);
	apoEdit->setEnabled(paflg==1);
	eccEdit->setEnabled(paflg!=1);
	n0Edit->setEnabled(paflg!=1);
	aEdit->setEnabled(paflg!=1);
  if (lcflg)
   {
    yearEdit->setEnabled(false);
    dayEdit->setEnabled(false);
    raEdit->setEnabled(false);
    aperEdit->setEnabled(false);
    m0Edit->setEnabled(false);
   };  
	ndotEdit->setEnabled(!aflg);
	adotEdit->setEnabled(!aflg);
	n2dotEdit->setEnabled(!aflg);
	bstarEdit->setEnabled(aflg);

	apc = 0;
	n0c = 0;
	ndc = 0;
}

void StEditOrbDialog::setParam2( double a, double ra, double aper, double inc, double ecc, double m0, double n0, double adot, double ndot, double n6dot, double bstar )
{
  QString s;

  dn0 = n0;
  dsmax = a;
  decc = ecc;
  dndot = ndot;
  dadot = adot;
    
	sprintf (ndat,"%12.4lf",a);
  s = ndat;
  aEdit->setText(s);
	sprintf (ndat,"%9.4lf",inc);
  s = ndat;
  incEdit->setText(s);
	sprintf (ndat,"%9.4lf",ra);
  s = ndat;
  raEdit->setText(s);
	sprintf (ndat,"%9.4lf",aper);
  s = ndat;
  aperEdit->setText(s);
	sprintf (ndat,"%9.4lf",m0);
  s = ndat;
  m0Edit->setText(s);
	if (decc < 1.0) sprintf (ndat,"%9.7lf",ecc);
	else sprintf (ndat,"%11.7lf",ecc);
  s = ndat;
  eccEdit->setText(s);
	sprintf (ndat,"%9.4lf",adot);
  s = ndat;
  adotEdit->setText(s);
	sprintf (ndat,"%12.8lf",ndot);
  s = ndat;
  ndotEdit->setText(s);
	if (decc < 1.0) sprintf (ndat,"%12.8lf",n0);
	else sprintf (ndat,"%12.4lf",n0);
  s = ndat;
  n0Edit->setText(s);
	sprintf (ndat,"%10.4le",n6dot);
  s = ndat;
  n2dotEdit->setText(s);
	sprintf (ndat,"%10.4le",bstar);
  s = ndat;
  bstarEdit->setText(s);

  if (decc < 1.0)
   {
	  hper = a*(1.0-ecc) - 6378.14;
	  sprintf (ndat,"%12.4lf",hper);
    s = ndat;
    periEdit->setText(s);
	  hapo = dsmax*(1.0+decc) - 6378.14;
	  sprintf (ndat,"%12.4lf",hapo);
    s = ndat;
	  apoEdit->setText(s);
   }
  else
    {
     s = "0.0";   
     periEdit->setText(s);
     apoEdit->setText(s);
     perapBox->setChecked(false);
     eccSlot();
    };  
}

void StEditOrbDialog::getParam1( QString &fsname, int &norad, int &aflg, int &paflg, double &mjdep, double &day )
{
  QString s;
  
  fsname = nameEdit->text();
  s = noradEdit->text();
  norad = s.toInt();
  s = yearEdit->text();
  mjdep = s.toDouble();
  s = dayEdit->text();
  day = s.toDouble();
  if (spg4Box->isChecked()) aflg = 1;
  else aflg = 0;
  if (perapBox->isChecked()) paflg = 1;
  else paflg = 0;
}

void StEditOrbDialog::getParam2( double &a, double &ra, double &aper, double &inc, double &ecc, double &m0, double &n0, double &adot, double &ndot, double &n6dot, double &bstar )
{
  QString s;

  refreshSlot();  
  n0 = dn0;
  a = dsmax;
  ecc = decc;
  ndot = dndot;
  adot = dadot;
  s = raEdit->text();
  ra = s.toDouble();
  s = aperEdit->text();
  aper = s.toDouble();
  s = incEdit->text();
  inc = s.toDouble();
  s = m0Edit->text();
  m0 = s.toDouble();
  s = n2dotEdit->text();
  n6dot = s.toDouble();
  s = bstarEdit->text();
  bstar = s.toDouble();

  if (n0 < 0.001) n0 = 0.001; // just in case
  if ((decc < 1.0) && (n0 > 100.0)) n0 = 100.0;
}

void StEditOrbDialog::stateSlot()
{
 double gm, t, t0, m0, a, ecc, ran, aper, inc;
 int day, month, year;
 double hour, r0, r1, r2, v0, v1, v2;
 bool nmflg, apsav, sgp4f;
 Vec3 rr1, vv1;
 QString s;
 
 gm = 2.97553635177984e15;

 apsav = perapBox->isChecked();
 s = yearEdit->text();
 year = s.toInt();
 s = dayEdit->text();
 hour = s.toDouble();
 t0 = mjd(0,1,year,0) + hour;
 t = t0;

 s = raEdit->text();
 ran = s.toDouble();
 s = aperEdit->text();
 aper = s.toDouble();
 s = incEdit->text();
 inc = s.toDouble();
 s = m0Edit->text();
 m0 = s.toDouble();
 s = eccEdit->text();
 ecc = s.toDouble();
 s = aEdit->text();
 a = s.toDouble();
 if (ecc >= 1.0)
  {
   if (a >= 0) a = -1000.0; 
   m0 = 0;
  }; 
 
 kepler (gm, t0, t, m0, a, ecc, ran, aper, inc, rr1, vv1);
 vv1 /= 86400.0;

 StStateDialog *dlg = new StStateDialog();
 r0 = rr1[0];
 r1 = rr1[1];
 r2 = rr1[2];
 v0 = vv1[0];
 v1 = vv1[1];
 v2 = vv1[2];
 nmflg = numBox->isChecked();
 sgp4f = spg4Box->isChecked();

 dlg->setParams(nmflg, year, hour, r0, r1, r2, v0, v1, v2, ecc);
  if (dlg->exec())
   {
    dlg->getParams(year, hour, r0, r1, r2, v0, v1, v2);
    rr1[0] = r0;
    rr1[1] = r1;
    rr1[2] = r2;
    vv1[0] = v0;
    vv1[1] = v1;
    vv1[2] = v2;
    vv1 *= 86400.0;

    s.setNum(year);
    yearEdit->setText(s);
    sprintf (ndat,"%12.8lf", hour);
    s = ndat;
    dayEdit->setText(s);
    t = mjd(0,1,year,0) + hour;
    numcng = false;
    oscelm (gm, t, rr1, vv1, t0, m0, a, ecc, ran, aper, inc);

    if (ecc >= 1.0)
     {
      caldat (t0, day, month, year, hour);
	    hour = t0 - mjd(0,1,year,0);
      s.setNum(year);
      yearEdit->setText(s);
      sprintf (ndat,"%12.8lf", hour);
      s = ndat;
      dayEdit->setText(s);
      sgp4f = false;
     };
    sprintf (ndat,"%12.4lf",a);
    s = ndat;
    aEdit->setText(s);
	  sprintf (ndat,"%9.4lf",inc);
    s = ndat;
    incEdit->setText(s);
	  sprintf (ndat,"%9.4lf",ran);
    s = ndat;
    raEdit->setText(s);
	  sprintf (ndat,"%9.4lf",aper);
    s = ndat;
    aperEdit->setText(s);
	  sprintf (ndat,"%9.4lf",m0);
    s = ndat;
    m0Edit->setText(s);
    decc = ecc;
	  if (decc < 1.0) sprintf (ndat,"%9.7lf",ecc);
	  else sprintf (ndat,"%11.7lf",ecc);
    s = ndat;
    eccEdit->setText(s);

    if (sgp4f)  // set to mean SGP4 elements.
     {
      cvSGP4(inc, ran, ecc, aper, m0, a);
      sprintf (ndat,"%12.8lf",a);
      s = ndat;
      n0Edit->setText(s);
	    sprintf (ndat,"%9.4lf",inc);
      s = ndat;
      incEdit->setText(s);
	    sprintf (ndat,"%9.4lf",ran);
      s = ndat;
      raEdit->setText(s);
	    sprintf (ndat,"%9.4lf",aper);
      s = ndat;
      aperEdit->setText(s);
	    sprintf (ndat,"%9.4lf",m0);
      s = ndat;
      m0Edit->setText(s);
      decc = ecc;
	    sprintf (ndat,"%9.7lf",ecc);
      s = ndat;
      eccEdit->setText(s);
     };

    if (apsav) perapBox->setChecked(false);
    if (sgp4f) n0Slot();
    else smaxSlot();
    refreshSlot();
    if(apsav && (ecc < 1.0))
     {
      perapBox->setChecked(true);
      refreshSlot();
     };  
   };  
}

void StEditOrbDialog::eccSlot()
{
 QString s;
 double secc;
 
 s = eccEdit->text(); 
 secc = s.toDouble();

 if (secc < 1.0)
  {
    eccincSlot();
    if (spg4Box->isChecked())
     {
      ndotEdit->setEnabled(false);
      adotEdit->setEnabled(false);
      n2dotEdit->setEnabled(false);
      bstarEdit->setEnabled(true);
     }
    else
    {
      ndotEdit->setEnabled(true);
      adotEdit->setEnabled(true);
      n2dotEdit->setEnabled(true);
      bstarEdit->setEnabled(false);
    };
  }
 else
  {
    if (n0c == 0) n0c = 1;
    spg4Box->setChecked(false);
    ndotEdit->setEnabled(false);
    adotEdit->setEnabled(false);
    n2dotEdit->setEnabled(false);
    bstarEdit->setEnabled(false);
  };
}

void StEditOrbDialog::timeSlot()
{
  int year, month, day, hour, minute, second, tzauto;
  double tzn, durt, rtoff;
  QString s;

  StDateDialog *dlg = new StDateDialog();
  s = yearEdit->text();
  durt = s.toDouble();
  s = dayEdit->text();
  tzn = s.toDouble();
	durt = mjd(0,1,int(durt),0) + tzn;
  caldat (durt, day, month, year, tzn);
  dms (tzn, hour, minute, durt);
  second = int(durt+0.001);

  if (second == 60)
   {
    second = 0;
    minute++;
   };
  dlg->setParams(year, month, day, hour, minute, second, 0.0, 0, -3.1, 0);
  if (dlg->exec())
   {
    dlg->getParams(year, month, day, hour, minute, second, tzn, tzauto, durt, rtoff);
    tzn = double(hour) -tzn + double(minute)/60.0 + double(second)/3600.0;
    durt = mjd(day, month, year, tzn);
	  tzn = durt - mjd(0,1,year,0);
    s.setNum(year);
    yearEdit->setText(s);
    sprintf (ndat,"%12.8lf", tzn);
    s = ndat;
    dayEdit->setText(s);
   }
}

void StEditOrbDialog::adjSlot()
{
  bool adjflg, usesdp4;
  int wgs;
  double adjtim, adjn0, adjra;
  
  StAdjDialog *dlj = new StAdjDialog();
  vsGetAdj(usesdp4, adjflg, adjtim, adjn0, adjra, wgs);
  
  dlj->setParams(usesdp4, adjflg, adjtim, adjn0, adjra, wgs);
  if (dlj->exec())
   {
    dlj->getParams(usesdp4, adjflg, adjtim, adjn0, adjra, wgs);
    vsPutAdj(usesdp4, adjflg, adjtim, adjn0, adjra, wgs);
   }; 
}

void StEditOrbDialog::geoSlot()
{
  bool ok;
  double res, mjdep, day;
  QString s;

  res = QInputDialog::getDouble(this, "GEO orbit", "Geogr.Longitude:",
                0.0, -180.0, 360.0, 2, &ok);
  if (ok)
   {
    s = yearEdit->text();
    mjdep = s.toDouble();
    s = dayEdit->text();
    day = s.toDouble();
	  mjdep = mjd(0,1,int(mjdep),0) + day;
    res = 15.0*lsidtim(mjdep, res, 0);
    if (res < 0.0) res += 360.0;
	  sprintf (ndat,"%9.4lf",res);
    s = ndat;
    raEdit->setText(s);
    res = 0.001;
	  sprintf (ndat,"%9.4lf",res);
    s = ndat;
    incEdit->setText(s);
    res = 0.0;
	  sprintf (ndat,"%9.4lf",res);
    s = ndat;
    aperEdit->setText(s);
    m0Edit->setText(s);
    adotEdit->setText(s);
	  sprintf (ndat,"%9.7lf",res);
    s = ndat;
    eccEdit->setText(s);
    res = 1.00270065;
	  sprintf (ndat,"%12.8lf",res);
    s = ndat;
    n0Edit->setText(s);
		res = getsax(0, res, 0.0, 0.001);
    sprintf (ndat,"%12.4lf",res);
    s = ndat;
    aEdit->setText(s);
    res = 0.0;
	  sprintf (ndat,"%10.4le",res);
    s = ndat;
    n2dotEdit->setText(s);
    bstarEdit->setText(s);
    spg4Box->setChecked(false);
    perapBox->setChecked(false);

    numBox->setChecked(false);
    smaxSlot();
    refreshSlot();
   };   
}

void StEditOrbDialog::setParam3( QString ldsn, bool numflg )
{
 double ecc, t0, hour;
 int day, month, year;
 QString s;
  
 idsnEdit->setText(ldsn);
 numBox->setChecked(numflg);
 numcng = false;
 ednwsflg = false;

 if (numflg) // the time displayed is perihelion passage for hyperbolic orbits
  {
   vsCkHyp(ecc, t0); 
   if (ecc >= 1.0)
    {
     caldat (t0, day, month, year, hour);
	   hour = t0 - mjd(0,1,year,0);
     s.setNum(year);
     yearEdit->setText(s);
     sprintf (ndat,"%12.8lf", hour);
     s = ndat;
     dayEdit->setText(s);
    };
  };  
}

void StEditOrbDialog::getParam3( QString &ldsn, bool& numflg , bool& nwsflg)
{
 ldsn = idsnEdit->text();
 numflg = numBox->isChecked();
 nwsflg = ednwsflg;
}

void StEditOrbDialog::numSlot()
{
 numcng = true;
}

void StEditOrbDialog::nwsSlot()
{
 ednwsflg = true;
}
