/********************************************************************************
********************************************************************************/

#include <QtGui>

#include "stiridiumdialog.h"

StIridiumDialog::StIridiumDialog()
{
        setObjectName(QString::fromUtf8("StIridiumDialog"));
        resize(348, 149);
        textLabel1 = new QLabel(this);
        textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
        textLabel1->setGeometry(QRect(20, 20, 178, 21));
        textLabel1->setWordWrap(false);
        magEdit = new QLineEdit(this);
        magEdit->setObjectName(QString::fromUtf8("magEdit"));
        magEdit->setGeometry(QRect(21, 38, 178, 21));
        opsBox = new QCheckBox(this);
        opsBox->setObjectName(QString::fromUtf8("opsBox"));
        opsBox->setGeometry(QRect(20, 70, 200, 21));
        okButton = new QPushButton(this);
        okButton->setObjectName(QString::fromUtf8("okButton"));
        okButton->setGeometry(QRect(251, 19, 78, 29));
        okButton->setDefault(true);
        cancelButton = new QPushButton(this);
        cancelButton->setObjectName(QString::fromUtf8("cancelButton"));
        cancelButton->setGeometry(QRect(251, 52, 78, 29));
        solpBox = new QCheckBox(this);
        solpBox->setObjectName(QString::fromUtf8("solpBox"));
        solpBox->setGeometry(QRect(20, 100, 270, 21));
#ifndef QT_NO_SHORTCUT
        textLabel1->setBuddy(magEdit);
#endif // QT_NO_SHORTCUT
        QWidget::setTabOrder(magEdit, opsBox);
        QWidget::setTabOrder(opsBox, solpBox);
        QWidget::setTabOrder(solpBox, okButton);
        QWidget::setTabOrder(okButton, cancelButton);

        connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
        connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));

        setWindowTitle(QApplication::translate("StIridiumDialog", "Iridium Flares", 0, QApplication::UnicodeUTF8));
        textLabel1->setText(QApplication::translate("StIridiumDialog", "&Minimum Magnitude:", 0, QApplication::UnicodeUTF8));
        opsBox->setText(QApplication::translate("StIridiumDialog", "O&perational Orbits Only", 0, QApplication::UnicodeUTF8));
        opsBox->setShortcut(QApplication::translate("StIridiumDialog", "Alt+P", 0, QApplication::UnicodeUTF8));
        okButton->setText(QApplication::translate("StIridiumDialog", "&OK", 0, QApplication::UnicodeUTF8));
        okButton->setShortcut(QApplication::translate("StIridiumDialog", "Alt+O", 0, QApplication::UnicodeUTF8));
        cancelButton->setText(QApplication::translate("StIridiumDialog", "&Cancel", 0, QApplication::UnicodeUTF8));
        cancelButton->setShortcut(QApplication::translate("StIridiumDialog", "Alt+C", 0, QApplication::UnicodeUTF8));
        solpBox->setText(QApplication::translate("StIridiumDialog", "Include &Solar Panel Flares", 0, QApplication::UnicodeUTF8));
        solpBox->setShortcut(QApplication::translate("StIridiumDialog", "Alt+S", 0, QApplication::UnicodeUTF8));

};

void StIridiumDialog::setParams( double mag, bool ops, bool irsol )
{
 QString s;
 
 s.setNum(mag);
 magEdit->setText(s);
 opsBox->setChecked(ops);
 solpBox->setChecked(irsol);
}

void StIridiumDialog::getParams( double &mag, bool &ops, bool &irsol)
{
 QString s;

  s=magEdit->text();
  mag = s.toDouble();
  ops = opsBox->isChecked();
  irsol = solpBox->isChecked();
}
