/********************************************************************************
********************************************************************************/

#ifndef STMAPDIALOG_H
#define STMAPDIALOG_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QDialog>
#include <QtGui/QGroupBox>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>

//QT_BEGIN_NAMESPACE

class StMapDialog : public QDialog
{
  Q_OBJECT

public:
   StMapDialog();

public slots:
    virtual void getParamF( int & mfsz, bool & bf, int & mapprj, double & centmer, double & frequ );
    virtual void setParamF( int mfsz, bool & bf, int mapprj, double centmer, double frequ, bool phwm );
    virtual void setParams( int mgrid, int mgrey, int skyprj, int mpnight, int skymap, int ra4d, double skaz );
    virtual void getParams( int & mgrid, int & mgrey, int & skyprj, int & mpnight, int & skymap, int & ra4d, double & skaz );
    virtual void showSlot();

private:
    QGroupBox *backGroup;
    QRadioButton *greyButton;
    QRadioButton *whiteButton;
    QRadioButton *blackButton;
    QGroupBox *gridGroup;
    QRadioButton *gnoButton;
    QRadioButton *g30Button;
    QRadioButton *g10Button;
    QCheckBox *skyBox;
    QCheckBox *fszBox;
    QCheckBox *boldBox;
    QCheckBox *nightBox;
    QCheckBox *ra4dBox;
    QLineEdit *azimEdit;
    QLabel *textLabel1;
    QPushButton *cancelButton;
    QPushButton *okButton;
    QLineEdit *frequEdit;
    QLabel *textLabel1_2;
    QLineEdit *meridianEdit;
    QLabel *textLabel2;
    QGroupBox *skyGroup;
    QRadioButton *eastButton;
    QRadioButton *southButton;
    QRadioButton *zenithButton;
    QRadioButton *azimButton;
    QRadioButton *northButton;
    QRadioButton *westButton;
    QGroupBox *mapGroup;
    QRadioButton *psouthButton;
    QRadioButton *pnorthButton;
    QRadioButton *pstdButton;
    QRadioButton *ppwmButton;

};

#endif // STMAPDIALOG_H
