/********************************************************************************
********************************************************************************/

#include <QtGui>

#include "stmatchdialog.h"

StMatchDialog::StMatchDialog()
{
        setObjectName(QString::fromUtf8("StMatchDialog"));
        resize(434, 228);
        azEdit = new QLineEdit(this);
        azEdit->setObjectName(QString::fromUtf8("azEdit"));
        azEdit->setGeometry(QRect(20, 40, 91, 24));
        raLabel = new QLabel(this);
        raLabel->setObjectName(QString::fromUtf8("raLabel"));
        raLabel->setGeometry(QRect(20, 10, 111, 31));
        raLabel->setWordWrap(false);
        elLabel = new QLabel(this);
        elLabel->setObjectName(QString::fromUtf8("elLabel"));
        elLabel->setGeometry(QRect(140, 10, 111, 31));
        elLabel->setWordWrap(false);
        elEdit = new QLineEdit(this);
        elEdit->setObjectName(QString::fromUtf8("elEdit"));
        elEdit->setGeometry(QRect(140, 40, 91, 24));
        textLabel3 = new QLabel(this);
        textLabel3->setObjectName(QString::fromUtf8("textLabel3"));
        textLabel3->setGeometry(QRect(20, 80, 131, 31));
        textLabel3->setFrameShape(QFrame::NoFrame);
        textLabel3->setFrameShadow(QFrame::Plain);
        textLabel3->setWordWrap(false);
        textLabel4 = new QLabel(this);
        textLabel4->setObjectName(QString::fromUtf8("textLabel4"));
        textLabel4->setGeometry(QRect(150, 80, 111, 31));
        textLabel4->setWordWrap(false);
        mxaEdit = new QLineEdit(this);
        mxaEdit->setObjectName(QString::fromUtf8("mxaEdit"));
        mxaEdit->setGeometry(QRect(20, 110, 91, 24));
        draEdit = new QLineEdit(this);
        draEdit->setObjectName(QString::fromUtf8("draEdit"));
        draEdit->setGeometry(QRect(150, 110, 81, 24));
        textLabel5 = new QLabel(this);
        textLabel5->setObjectName(QString::fromUtf8("textLabel5"));
        textLabel5->setGeometry(QRect(20, 140, 138, 31));
        textLabel5->setWordWrap(false);
        tmEdit = new QLineEdit(this);
        tmEdit->setObjectName(QString::fromUtf8("tmEdit"));
        tmEdit->setGeometry(QRect(20, 170, 101, 24));
        okButton = new QPushButton(this);
        okButton->setObjectName(QString::fromUtf8("okButton"));
        okButton->setGeometry(QRect(350, 130, 71, 29));
        okButton->setDefault(true);
        cancelButton = new QPushButton(this);
        cancelButton->setObjectName(QString::fromUtf8("cancelButton"));
        cancelButton->setGeometry(QRect(350, 170, 71, 29));
        raBox = new QCheckBox(this);
        raBox->setObjectName(QString::fromUtf8("raBox"));
        raBox->setGeometry(QRect(250, 40, 161, 21));
        drfBox = new QCheckBox(this);
        drfBox->setObjectName(QString::fromUtf8("drfBox"));
        drfBox->setGeometry(QRect(250, 100, 141, 30));
        visBox = new QCheckBox(this);
        visBox->setObjectName(QString::fromUtf8("visBox"));
        visBox->setGeometry(QRect(150, 170, 181, 21));
#ifndef QT_NO_SHORTCUT
        raLabel->setBuddy(azEdit);
        elLabel->setBuddy(elEdit);
        textLabel3->setBuddy(mxaEdit);
        textLabel4->setBuddy(draEdit);
        textLabel5->setBuddy(tmEdit);
#endif // QT_NO_SHORTCUT
        QWidget::setTabOrder(azEdit, elEdit);
        QWidget::setTabOrder(elEdit, raBox);
        QWidget::setTabOrder(raBox, mxaEdit);
        QWidget::setTabOrder(mxaEdit, draEdit);
        QWidget::setTabOrder(draEdit, drfBox);
        QWidget::setTabOrder(drfBox, visBox);
        QWidget::setTabOrder(visBox, tmEdit);
        QWidget::setTabOrder(tmEdit, okButton);
        QWidget::setTabOrder(okButton, cancelButton);

        connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
        connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));
        connect(raBox, SIGNAL(toggled(bool)), this, SLOT(raSlot()));
        connect(drfBox, SIGNAL(toggled(bool)), this, SLOT(dirSlot()));

        setWindowTitle(QApplication::translate("StMatchDialog", "Find Matching Satellites", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        azEdit->setToolTip(QApplication::translate("StMatchDialog", "Center position", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        azEdit->setWhatsThis(QApplication::translate("StMatchDialog", "Azimuth or R.A.of center position", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
#ifndef QT_NO_TOOLTIP
        raLabel->setToolTip(QApplication::translate("StMatchDialog", "Center position", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        raLabel->setWhatsThis(QApplication::translate("StMatchDialog", "Azimuth or R.A. of center position", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        raLabel->setText(QApplication::translate("StMatchDialog", "&Azimuth (deg):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        elLabel->setToolTip(QApplication::translate("StMatchDialog", "Center position", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        elLabel->setWhatsThis(QApplication::translate("StMatchDialog", "Elevation or  declination of center position.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        elLabel->setText(QApplication::translate("StMatchDialog", "&Elevation (deg):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        elEdit->setToolTip(QApplication::translate("StMatchDialog", "Center position", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        elEdit->setWhatsThis(QApplication::translate("StMatchDialog", "Elevation or Declination of center position", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
#ifndef QT_NO_TOOLTIP
        textLabel3->setToolTip(QApplication::translate("StMatchDialog", "Angular distance", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel3->setWhatsThis(QApplication::translate("StMatchDialog", "Maximum angular distance from center position", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel3->setText(QApplication::translate("StMatchDialog", "&Max.Distance (deg):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        textLabel4->setToolTip(QApplication::translate("StMatchDialog", "Direction of satellite movement", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel4->setWhatsThis(QApplication::translate("StMatchDialog", "The direction is 90\302\260 for movement to the right, -90\302\260 to the left, 0\302\260 up etc.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel4->setText(QApplication::translate("StMatchDialog", "&Direction (deg):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        mxaEdit->setToolTip(QApplication::translate("StMatchDialog", "Angular distance", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        mxaEdit->setWhatsThis(QApplication::translate("StMatchDialog", "Maximum angular distance from center position.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
#ifndef QT_NO_TOOLTIP
        draEdit->setToolTip(QApplication::translate("StMatchDialog", "Direction of satellite movement", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        draEdit->setWhatsThis(QApplication::translate("StMatchDialog", "The direction is 90\302\260 for movement to the right, -90\302\260 to the left, 0\302\260 up etc.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
#ifndef QT_NO_TOOLTIP
        textLabel5->setToolTip(QApplication::translate("StMatchDialog", "Time interval for search", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        textLabel5->setWhatsThis(QApplication::translate("StMatchDialog", "Maximum time interval +/- for search.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        textLabel5->setText(QApplication::translate("StMatchDialog", "&Time Interval (min):", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        tmEdit->setToolTip(QApplication::translate("StMatchDialog", "Time interval for search", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        tmEdit->setWhatsThis(QApplication::translate("StMatchDialog", "Maximum time interval +/- for search.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        okButton->setText(QApplication::translate("StMatchDialog", "&OK", 0, QApplication::UnicodeUTF8));
        okButton->setShortcut(QApplication::translate("StMatchDialog", "Alt+O", 0, QApplication::UnicodeUTF8));
        cancelButton->setText(QApplication::translate("StMatchDialog", "&Cancel", 0, QApplication::UnicodeUTF8));
        cancelButton->setShortcut(QApplication::translate("StMatchDialog", "Alt+C", 0, QApplication::UnicodeUTF8));
        raBox->setText(QApplication::translate("StMatchDialog", "&Position as R.A./Dec.", 0, QApplication::UnicodeUTF8));
        raBox->setShortcut(QApplication::translate("StMatchDialog", "Alt+P", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        drfBox->setToolTip(QApplication::translate("StMatchDialog", "Filter for satellite direction", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        drfBox->setWhatsThis(QApplication::translate("StMatchDialog", "The satellite will be accepted, if movement is within 45\302\260 of specified direction.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        drfBox->setText(QApplication::translate("StMatchDialog", "Direction &Search", 0, QApplication::UnicodeUTF8));
        drfBox->setShortcut(QApplication::translate("StMatchDialog", "Alt+S", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        visBox->setToolTip(QApplication::translate("StMatchDialog", "Search for major objects only.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        visBox->setWhatsThis(QApplication::translate("StMatchDialog", "Objects with an International Launch Designation ending with F or higher will mostly be small fragment debris. Those will be ignored. ", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        visBox->setText(QApplication::translate("StMatchDialog", "&Brighter Objects Only", 0, QApplication::UnicodeUTF8));
};

void StMatchDialog::raSlot()
{
 if (raBox->isChecked()) 
  {
     raLabel->setText("R.&A. (HH.MMSS):");
     elLabel->setText("D&ec. (DD.MMSS):");
  }
 else
  {
     raLabel->setText("&Azimuth (deg):");
     elLabel->setText("&Elevation (deg):");
  };
}

void StMatchDialog::dirSlot()
{
 if (drfBox->isChecked()) draEdit->setEnabled(true);
 else draEdit->setEnabled(false);
}

void StMatchDialog::setParams( double az, double el, double mxa, double dra, double tm, bool rdf, bool drf, bool vis )
{
 QString s;
 
 s.setNum(az);
 azEdit->setText(s);
 s.setNum(el);
 elEdit->setText(s);
 s.setNum(mxa);
 mxaEdit->setText(s);
 s.setNum(dra);
 draEdit->setText(s);
 s.setNum(tm);
 tmEdit->setText(s);
 raBox->setChecked(rdf);
 drfBox->setChecked(drf);
 visBox->setChecked(vis);
 raSlot();
 dirSlot();
}


void StMatchDialog::getParams( double &az, double &el, double &mxa, double &dra, double &tm, bool &rdf, bool &drf, bool &vis )
{
 QString s;

  s=azEdit->text();
  az = s.toDouble();
  s=elEdit->text();
  el = s.toDouble();
  s=mxaEdit->text();
  mxa = s.toDouble();
  s=draEdit->text();
  dra = s.toDouble();
  s=tmEdit->text();
  tm = s.toDouble();
  rdf = raBox->isChecked(); 
  drf = drfBox->isChecked();
  vis = visBox->isChecked();
}
