/********************************************************************************
********************************************************************************/

#include <QtGui>

#include "stobsdialog.h"
#include "satccom.h"
#include <cmath>

StObsDialog::StObsDialog()
{
        setObjectName(QString::fromUtf8("StObsDialog"));
        resize(495, 309);
        okButton = new QPushButton(this);
        okButton->setObjectName(QString::fromUtf8("okButton"));
        okButton->setGeometry(QRect(401, 25, 78, 29));
        okButton->setDefault(true);
        textLabel1 = new QLabel(this);
        textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
        textLabel1->setGeometry(QRect(21, 11, 135, 21));
        textLabel1->setWordWrap(false);
        latEdit = new QLineEdit(this);
        latEdit->setObjectName(QString::fromUtf8("latEdit"));
        latEdit->setGeometry(QRect(21, 38, 135, 21));
        textLabel2 = new QLabel(this);
        textLabel2->setObjectName(QString::fromUtf8("textLabel2"));
        textLabel2->setGeometry(QRect(21, 71, 135, 21));
        textLabel2->setWordWrap(false);
        lngEdit = new QLineEdit(this);
        lngEdit->setObjectName(QString::fromUtf8("lngEdit"));
        lngEdit->setGeometry(QRect(21, 98, 135, 21));
        textLabel3 = new QLabel(this);
        textLabel3->setObjectName(QString::fromUtf8("textLabel3"));
        textLabel3->setGeometry(QRect(21, 131, 135, 21));
        textLabel3->setWordWrap(false);
        heightEdit = new QLineEdit(this);
        heightEdit->setObjectName(QString::fromUtf8("heightEdit"));
        heightEdit->setGeometry(QRect(21, 158, 135, 21));
        textLabel4 = new QLabel(this);
        textLabel4->setObjectName(QString::fromUtf8("textLabel4"));
        textLabel4->setGeometry(QRect(22, 191, 371, 28));
        textLabel4->setFrameShape(QFrame::NoFrame);
        textLabel4->setFrameShadow(QFrame::Plain);
        textLabel4->setWordWrap(false);
        textLabel5 = new QLabel(this);
        textLabel5->setObjectName(QString::fromUtf8("textLabel5"));
        textLabel5->setGeometry(QRect(21, 259, 440, 30));
        textLabel5->setFrameShape(QFrame::NoFrame);
        textLabel5->setFrameShadow(QFrame::Plain);
        textLabel5->setWordWrap(false);
        locEdit = new QLineEdit(this);
        locEdit->setObjectName(QString::fromUtf8("locEdit"));
        locEdit->setGeometry(QRect(22, 225, 371, 21));
        ddmmGroup = new QGroupBox(this);
        ddmmGroup->setObjectName(QString::fromUtf8("ddmmGroup"));
        ddmmGroup->setGeometry(QRect(164, 23, 220, 110));
      // ####  ddmmGroup->setOrientation(Qt::Vertical);
        decButton = new QRadioButton(ddmmGroup);
        decButton->setObjectName(QString::fromUtf8("decButton"));
        decButton->setGeometry(QRect(20, 30, 190, 21));
        ddmmButton = new QRadioButton(ddmmGroup);
        ddmmButton->setObjectName(QString::fromUtf8("ddmmButton"));
        ddmmButton->setGeometry(QRect(20, 70, 170, 21));
        cancelButton = new QPushButton(this);
        cancelButton->setObjectName(QString::fromUtf8("cancelButton"));
        cancelButton->setGeometry(QRect(401, 64, 78, 29));
#ifndef QT_NO_SHORTCUT
        textLabel1->setBuddy(latEdit);
        textLabel2->setBuddy(lngEdit);
        textLabel3->setBuddy(heightEdit);
        textLabel4->setBuddy(locEdit);
#endif // QT_NO_SHORTCUT
        QWidget::setTabOrder(latEdit, lngEdit);
        QWidget::setTabOrder(lngEdit, heightEdit);
        QWidget::setTabOrder(heightEdit, locEdit);
        QWidget::setTabOrder(locEdit, decButton);
        QWidget::setTabOrder(decButton, ddmmButton);
        QWidget::setTabOrder(ddmmButton, okButton);
        QWidget::setTabOrder(okButton, cancelButton);

        connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
        connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));
        connect(decButton, SIGNAL(clicked()), this, SLOT(setDec()));
        connect(ddmmButton, SIGNAL(clicked()), this, SLOT(setDdmm()));

        setWindowTitle(QApplication::translate("StObsDialog", "Observer's Location", 0, QApplication::UnicodeUTF8));
        okButton->setText(QApplication::translate("StObsDialog", "&OK", 0, QApplication::UnicodeUTF8));
        okButton->setShortcut(QApplication::translate("StObsDialog", "Alt+O", 0, QApplication::UnicodeUTF8));
        textLabel1->setText(QApplication::translate("StObsDialog", "L&atitude in deg.:", 0, QApplication::UnicodeUTF8));
        textLabel2->setText(QApplication::translate("StObsDialog", "L&ongitude in deg.:", 0, QApplication::UnicodeUTF8));
        textLabel3->setText(QApplication::translate("StObsDialog", "&Height (in m):", 0, QApplication::UnicodeUTF8));
        textLabel4->setText(QApplication::translate("StObsDialog", "&Name of Location:", 0, QApplication::UnicodeUTF8));
        textLabel5->setText(QApplication::translate("StObsDialog", "Western longitudes and Southern latitudes are negative", 0, QApplication::UnicodeUTF8));
#ifndef QT_NO_TOOLTIP
        ddmmGroup->setToolTip(QApplication::translate("StObsDialog", "Switch between decimal degrees and Degrees/Minutes/Seconds", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_TOOLTIP
#ifndef QT_NO_WHATSTHIS
        ddmmGroup->setWhatsThis(QApplication::translate("StObsDialog", "This setting will also be used for the display of geographic coordinates on the world map.", 0, QApplication::UnicodeUTF8));
#endif // QT_NO_WHATSTHIS
        ddmmGroup->setTitle(QApplication::translate("StObsDialog", "Latitude/Longitude", 0, QApplication::UnicodeUTF8));
        decButton->setText(QApplication::translate("StObsDialog", "Decimal Degrees", 0, QApplication::UnicodeUTF8));
        ddmmButton->setText(QApplication::translate("StObsDialog", "Degrees in DD.MMSS", 0, QApplication::UnicodeUTF8));
        cancelButton->setText(QApplication::translate("StObsDialog", "&Cancel", 0, QApplication::UnicodeUTF8));
        cancelButton->setShortcut(QApplication::translate("StObsDialog", "Alt+C", 0, QApplication::UnicodeUTF8));
};

void StObsDialog::setParams( double lat, double lng, double height, char * geoname, bool ddmm )
{
 QString s1;
 char crlng[21];
 double f;
 
 s1.setNum(lat);
 latEdit->setText(s1);
 if (fabs(lng) > 100.0)
  {
	 sprintf (crlng,"%10.4lf",lng);
   s1 = crlng;
  }
 else s1.setNum(lng);
 lngEdit->setText(s1);
 s1.setNum(height);
 heightEdit->setText(s1);
 s1 = geoname;
 locEdit->setText(s1);
 
 if (ddmm)
  {
   ddmmButton->setChecked(true);
   decButton->setChecked(false);
   f = DegFDms(lat);
   s1.setNum(f);
   latEdit->setText(s1);

   f = DegFDms(lng);
   if (fabs(f) > 100.0)
    {
	   sprintf (crlng,"%10.4lf",f);
     s1 = crlng;
    }
   else s1.setNum(f);
   lngEdit->setText(s1);
  }
else
  {
    decButton->setChecked(true);
    ddmmButton->setChecked(false);
  };
}

void StObsDialog::getParams( double &lat, double &lng, double &height, bool &ddmm )
{
 QString s1;

  s1=latEdit->text();
  lat = s1.toDouble();
  s1=lngEdit->text();
  lng = s1.toDouble();
  s1=heightEdit->text();
  height = s1.toDouble();
  ddmm = ddmmButton->isChecked();
  if (ddmm)
   {
     lat = DmsDegF(lat); 
     lng = DmsDegF(lng);
   };
}

QString StObsDialog::getGeoname()
{
  return(locEdit->text());
}  

void StObsDialog::setDec()
{
 QString s1;
 char crlng[21];
 double d, f;

 if(decButton->isChecked())
  {
   s1=latEdit->text();
   d = s1.toDouble();
   f = DmsDegF(d); 
   s1.setNum(f);
   latEdit->setText(s1);
 
   s1=lngEdit->text();
   d = s1.toDouble();
   f = DmsDegF(d); 
   if (fabs(f) > 100.0)
    {
     sprintf (crlng,"%10.4lf",f);
     s1 = crlng;
    }
   else s1.setNum(f);
   lngEdit->setText(s1);
  }; 
}

void StObsDialog::setDdmm()
{
 QString s1;
 char crlng[21];
 double d, f;

 if(ddmmButton->isChecked())
  {
   s1=latEdit->text();
   d = s1.toDouble();
   f = DegFDms(d); 
   s1.setNum(f);
   latEdit->setText(s1);
 
   s1=lngEdit->text();
   d = s1.toDouble();
   f = DegFDms(d); 
   if (fabs(f) > 100.0)
    {
     sprintf (crlng,"%10.4lf",f);
     s1 = crlng;
    }
   else s1.setNum(f);
   lngEdit->setText(s1);
   };
}
