/********************************************************************************
********************************************************************************/

#include <QtGui>

#include "ststepdialog.h"

StStepDialog::StStepDialog()
{
        setObjectName(QString::fromUtf8("StStepDialog"));
        resize(208, 131);
        minEdit = new QLineEdit(this);
        minEdit->setObjectName(QString::fromUtf8("minEdit"));
        minEdit->setGeometry(QRect(21, 31, 71, 24));
        secEdit = new QLineEdit(this);
        secEdit->setObjectName(QString::fromUtf8("secEdit"));
        secEdit->setGeometry(QRect(21, 88, 71, 24));
        textLabel1 = new QLabel(this);
        textLabel1->setObjectName(QString::fromUtf8("textLabel1"));
        textLabel1->setGeometry(QRect(21, 11, 88, 20));
        textLabel1->setWordWrap(false);
        textLabel2 = new QLabel(this);
        textLabel2->setObjectName(QString::fromUtf8("textLabel2"));
        textLabel2->setGeometry(QRect(21, 68, 88, 20));
        textLabel2->setWordWrap(false);
        okButton = new QPushButton(this);
        okButton->setObjectName(QString::fromUtf8("okButton"));
        okButton->setGeometry(QRect(120, 40, 71, 29));
        okButton->setDefault(true);
        cancelButton = new QPushButton(this);
        cancelButton->setObjectName(QString::fromUtf8("cancelButton"));
        cancelButton->setGeometry(QRect(120, 80, 71, 29));
#ifndef QT_NO_SHORTCUT
        textLabel1->setBuddy(minEdit);
        textLabel2->setBuddy(secEdit);
#endif // QT_NO_SHORTCUT
        QWidget::setTabOrder(secEdit, minEdit);
        QWidget::setTabOrder(minEdit, okButton);
        QWidget::setTabOrder(okButton, cancelButton);

        connect(okButton, SIGNAL(clicked()), this, SLOT(accept()));
        connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));

        setWindowTitle(QApplication::translate("StStepDialog", "Time Step", 0, QApplication::UnicodeUTF8));
        textLabel1->setText(QApplication::translate("StStepDialog", "&Minutes:", 0, QApplication::UnicodeUTF8));
        textLabel2->setText(QApplication::translate("StStepDialog", "&Seconds:", 0, QApplication::UnicodeUTF8));
        okButton->setText(QApplication::translate("StStepDialog", "&OK", 0, QApplication::UnicodeUTF8));
        okButton->setShortcut(QApplication::translate("StStepDialog", "Alt+O", 0, QApplication::UnicodeUTF8));
        cancelButton->setText(QApplication::translate("StStepDialog", "&Cancel", 0, QApplication::UnicodeUTF8));
        cancelButton->setShortcut(QApplication::translate("StStepDialog", "Alt+C", 0, QApplication::UnicodeUTF8));

};

void StStepDialog::setParams( int min, double sec )
{
  QString s;
  
  s.setNum(min);
  minEdit->setText(s);
  s.setNum(sec);
  secEdit->setText(s);
}

void StStepDialog::getParams( int &min, double &sec )
{
  QString s;
  
  s = minEdit->text();
  min = s.toInt();
  s = secEdit->text();
  sec = s.toDouble();
}
