/********************************************************************************
********************************************************************************/

#ifndef STSYSCONFDIALOG_H
#define STSYSCONFDIALOG_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QDialog>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QPushButton>

//QT_BEGIN_NAMESPACE

class StSysConfDialog : public QDialog
{
  Q_OBJECT

public:
   StSysConfDialog();

public slots:
    virtual void setParams( double RKFtol, double dF107, double dFB107, double dKp, double dCd, double dCr, double dAm, double lift, bool sunf, bool moonf, bool refrc, int mxit, bool atmx );
    virtual void getParams( double & RKFtol, double & dF107, double & dFB107, double & dKp, double & dCd, double & dCr, double & dAm, double & lift, bool & sunf, bool & moonf, bool & refrc, int & mxit, bool & atmx );

private:
    QLabel *textLabel1;
    QLineEdit *tolEdit;
    QLineEdit *mxiEdit;
    QPushButton *okButton;
    QPushButton *cancelButton;
    QLineEdit *liftEdit;
    QLabel *textLabel1_3;
    QLineEdit *dragEdit;
    QLabel *textLabel7;
    QLineEdit *crEdit;
    QLabel *textLabel6;
    QLabel *textLabel8;
    QLineEdit *amEdit;
    QLabel *textLabel9;
    QLabel *textLabel2;
    QLabel *textLabel3;
    QLineEdit *fb107Edit;
    QLabel *textLabel4;
    QLineEdit *f107Edit;
    QCheckBox *sunBox;
    QCheckBox *moonBox;
    QCheckBox *refractBox;
    QLabel *textLabel1_2;
    QLabel *textLabel5;
    QLineEdit *kpEdit;
    QCheckBox *atxBox;

};

#endif // STSYSCONFDIALOG_H
